# guinget Version 0.1 Pre-Alpha 1 Changelog
Released on 6/5/2020 (MM/DD/YYYY).

guinget is now ready for its first pre-release at Version 0.1 Pre-Alpha 1, and it only took about two weeks from starting the project until now! Couldn't have done it without both Microsoft's [winget/Windows Package Manager](https://github.com/microsoft/winget-cli) and [YamlDotNet](https://github.com/aaubry/YamlDotNet). guinget takes heavy inspiration from [Synaptic Package Manager](https://en.wikipedia.org/wiki/Synaptic_(software)) as well, so I need to give credit there. Please be sure to read the Readme included with guinget or [online](https://github.com/DrewNaylor/guinget/blob/master/docs/readmes/readme-v0.1-prealpha1.txt) as it has important info. Also refer to the [System Requirements](https://github.com/DrewNaylor/guinget/blob/master/docs/system-requirements.md).

If you are reading this in Notepad or another text editor, it displays best in Word Wrap view. Click on Format>Word Wrap on the top bar. Notepad++ users will find it under View>Word Wrap. Word Wrap is automatically done if viewing on GitHub or on the website.

## Hashes

MD5 checksums/hashes are not used for guinget as they are weaker than SHA-256. [More details](https://github.com/DrewNaylor/UXL-Launcher/issues/124), though they're not as relevant to guinget:


You can use Windows PowerShell to confirm the hash of the main guinget EXE file by running
Get-FileHash .\guinget.exe -Algorithm SHA256 in the folder you extracted the archive to and comparing the output to my sums listed below. HowToGeek has a nice [article on this](https://www.howtogeek.com/67241/htg-explains-what-are-md5-sha-1-hashes-and-how-do-i-check-them/), but the Windows section is a bit further down on the page.

The PowerShell method can be used for all files listed below.

SHA-256 sum for "guinget.exe" in the archive:
D54E9A09F9FD2DF783ABFEBC0C7B40240F46EBEE6CEDF2548E1F85D79F6FB14D

SHA-256 sum for "libguinget.dll" in the archive:
09284FABF19CE274F4DFE8C0CB74E5440CAD49100CEBF72AF19F740A51AE1BBD

SHA-256 sum for "update-manifests.bat" in the archive:
AFA421669D4856FB9136656B97CD2098478B1FE67AD5CB2326DA5A8BDA4BD36A

SHA-256 sum for "YamlDotNet.dll" in the archive:
632E1C37E67E5BE46766FFC9ED7790C22D1FE75A5B83AAB9EC4C0678414E5B82



## Features

Instead of a standard changelog, I'm going to list some features of guinget.

- One or multiple packages can be marked to be "Installed" or "Do nothing" (ignored, basically)
  - Package selection can be done multiple ways:
    - Through the package context menu's `Action` submenu (double-click and right-click both work to open the menu, though only right-click allows multiple packages to be selected and marked at once)
	- From the `Package list>Selected package>Action` submenu
	- By changing the combobox dropdown's value in the `Action` column. Changing the value in the dropdown may take a few clicks to open it, so it may be easier to use the context menu or simply use the arrow keys to move over to it and press `spacebar` to activate it, allowing the `up` and `down` arrow keys to mark as desired.
  - Multiple packages can be selected by using `Ctrl+Click`, `Shift-Click`, or `Shift+arrow keys`.
  - At the moment, marking a lot of packages at once (say, over 50 packages) may take a long time and you won't be able to interact with the window while it's marking them. I want to make this async so that the window can be moved around and stuff, but that's not something I've figured out how to do well yet.
- Package list can be sorted by different columns, and these columns can be resized and moved. These columns include:
  - Action ("do nothing" or "install" for now) 
  - Status ("unknown" for now, since guinget doesn't track whether a package is installed or not yet) 
  - Package (displays the ID for each package; copied into the Apply changes dialog)
  - Name (the common name for a package as opposed to its ID)
  - Version (for now it shows all the versions available, but I'd like it to show only the latest version in the column so it's cleaner and put the rest in another window, just like what Synaptic does; copied into the Apply changes dialog)
  - Description
- Details for each package are shown in the package details textbox below the package list. If you want to, you can resize this textbox since it uses a split view control.
- Package list cache is stored in `%AppData%\winget-frontends\source\winget-pkgs\pkglist\manifests` and can be refreshed using any of the following methods:
  - Clicking the `Refresh cache` button on the toolbar.
  - Using `Package list>Refresh cache` from the menubar.
  - Pressing `Ctrl+R`.
  - Running `update-manifests.bat` directly. Please note that guinget still opens this script every time you refresh the cache, so you'll have to type `no` or close the script if you don't want it updating again if you just ran it manually.
- The package list cache as mentioned above is used to fill the package list once you're ready and you've dismissed the last message box before the package list loads.
- Other sources can have their manifests placed into `%AppData%\winget-frontends\source\(source name)\pkglist\manifests`, but only `Microsoft/winget-pkgs` is supported by guinget and `update-manifests.bat` for now.
- That package cache location can be used by other winget frontends if they wish to use it, but there's no way to check yet if something is using the folder like APT with its lock file. This feature is planned.
- Package selections are applied using the `Apply changes` dialog, which you can access from either its toolbar button, or from `Package list>Apply changes...`
  - For now, this dialog doesn't support batch installs (or uninstalls, whenever winget [and guinget, by extension] gets that feature), so you'll have to install packages either by double-clicking on each one in the list, or by pressing `Enter` on each one, when you're ready to start each package's install.
  - The `Confirm changes` button currently just shows a message box displaying something similar to the item above this one.
- Any controls that don't have their features fully implemented are hidden by default, but you can show them in one of two ways:
  - Temporarily (until closing and restarting guinget) by clicking a hidden label in the bottom-left corner of the About window.
  - Semi-permanently (until the next guinget update) by opening the config file and changing the value for `HideUnfinishedControls` from `True` to `False`.


## Links

[Releases page with downloads for this version](https://github.com/DrewNaylor/guinget/releases/tag/v0.1-prealpha1)