# guinget Version 0.1 Pre-Alpha 2 Changelog
Released on 6/8/2020 (MM/DD/YYYY).

Only three days after the first pre-release, a new pre-release version is ready! Even though there aren't many changes in this version, what has been changed has made a major difference for usability in my opinion. Please be sure to read the Readme included with this version of guinget or [online](https://github.com/DrewNaylor/guinget/blob/master/docs/readmes/readme-v0.1-prealpha2.txt) as it has important info. Also refer to the [System Requirements](https://github.com/DrewNaylor/guinget/blob/master/docs/system-requirements.md).

If you are reading this in Notepad or another text editor, it displays best in Word Wrap view. Click on Format>Word Wrap on the top bar. Notepad++ users will find it under View>Word Wrap. Word Wrap is automatically done if viewing on GitHub or on the website.

## Hashes

MD5 checksums/hashes are not used for guinget as they are weaker than SHA-256. [More details](https://github.com/DrewNaylor/UXL-Launcher/issues/124), though they're not as relevant to guinget:


You can use Windows PowerShell to confirm the hash of the main guinget EXE file by running
`Get-FileHash .\guinget.exe -Algorithm SHA256` in the folder you extracted the archive to and comparing the output to my sums listed below. HowToGeek has a nice [article on this](https://www.howtogeek.com/67241/htg-explains-what-are-md5-sha-1-hashes-and-how-do-i-check-them/), but the Windows section is a bit further down on the page.

The PowerShell method can be used for all files listed below, though you'll have to switch out the filenames.

SHA-256 sum for "guinget.exe" in the archive:
9E93D482550551BF0529BF1CB26AF0B9562622760ECCD9BE30F0293031F414BF

SHA-256 sum for "libguinget.dll" in the archive:
7886890B0BC4168FDFFB853ACAB6313B77CDBF4E7905006FA64186F522496AC5

SHA-256 sum for "update-manifests.bat" in the archive:
AFA421669D4856FB9136656B97CD2098478B1FE67AD5CB2326DA5A8BDA4BD36A

SHA-256 sum for "YamlDotNet.dll" in the archive:
632E1C37E67E5BE46766FFC9ED7790C22D1FE75A5B83AAB9EC4C0678414E5B82



## Added

- You can now search for packages using the search bar available in the toolbar.
  - For now, this only searches in the `Package` column, but searching in other columns is planned.
  - Activating the search box is done in multiple ways:
    - Simply clicking the search box
    - Pressing `Ctrl+F`
    - Choosing `Package list>Search` from the menubar
  - Starting a search can be done in a few ways:
    - Pressing `Enter` once you're done typing
    - Clicking the `Search` toolbar button
  - If there are no packages loaded, searching won't do anything.
  - Please be aware that [using `Ctrl+A` to select all packages in the search results currently selects even non-filtered packages](https://github.com/DrewNaylor/guinget/issues/13).
  - At the moment, you'll have to manually clear the search box and search again to get back to the non-filtered package list.
  
## Changed

- Marking many packages at once is now almost instant as column auto-sizing is turned off while marking packages if more than 25 are selected to be marked.
  - The threshold of selected packages that determines whether we should disable column auto-sizing while marking selected packages could change in the future, and it may eventually be a setting the user can change.
  - Previously, column auto-sizing wasn't disabled, and marking an excessive number of packages would take way too long. Now the entire list can be marked in what feels like less than a second or two (even though that's not recommended), while before it would take an extremely long amount of time. It was awful, just awful.
- Instead of saying "# packages listed", we're now saying "# packages loaded" as we don't yet have a way to show the current number of visible rows. Once we do have that available, it'll be changed back so that the number of packages listed updates as the list is filtered.
- The [project roadmap](https://github.com/DrewNaylor/guinget/blob/master/docs/Project-roadmap.md) has been thinned out a bit to spread features and changes across more versions to get newer versions out faster.

## Links

[Releases page with downloads for this version](https://github.com/DrewNaylor/guinget/releases/tag/v0.1-prealpha2)