# guinget Version 0.1.0.1 Alpha Changelog
Released on 7/21/2020 (MM/DD/YYYY).

Didn't think the `-e` would be important when the package is passed to winget, but it [turns out that there's a bug](https://github.com/DrewNaylor/guinget/issues/24) where some packages can't be installed without specifying the exact package name. This issue didn't show up until I tried to install CrystalDiskMark and it wouldn't work since there were conflicting package names. Ended up that the `-e` (exact) is just as important here as it is in some other situations outside winget. Since this is a major bug, I'm doing a quick bugfix update.

Some packages like CrystalDiskMark and LibreOffice may require administrative permissions to install, so you'll have to run guinget as an administrator.

Please be sure to read the Readme included with this version of guinget or [online](https://github.com/DrewNaylor/guinget/blob/master/docs/readmes/readme-v0.1.0.1-alpha.txt) as it has important info. Also refer to the [System Requirements](https://github.com/DrewNaylor/guinget/blob/master/docs/system-requirements.md).

If you are reading this in Notepad or another text editor, it displays best in Word Wrap view. Click on Format>Word Wrap on the top bar. Notepad++ users will find it under View>Word Wrap. Word Wrap is automatically done if viewing on GitHub or on the website.

## Hashes

MD5 checksums/hashes are not used for guinget as they are weaker than SHA-256. [More details](https://github.com/DrewNaylor/UXL-Launcher/issues/124), though they're not as relevant to guinget:


You can use Windows PowerShell to confirm the hash of the main guinget EXE file by running
`Get-FileHash .\guinget.exe -Algorithm SHA256` in the folder you extracted the archive to and comparing the output to my sums listed below. HowToGeek has a nice [article on this](https://www.howtogeek.com/67241/htg-explains-what-are-md5-sha-1-hashes-and-how-do-i-check-them/), but the Windows section is a bit further down on the page.

The PowerShell method can be used for all files listed below, though you'll have to switch out the filenames.

SHA-256 sum for "guinget_v0.1.0.1-alpha-quieter.exe", which is a quieter installer without the startup message:
9063573663D99ADF58397B9D7E683F437BE362E850DCECF346CF62BCE5A292E5

SHA-256 sum for "guinget_v0.1.0.1-alpha.exe", which is the installer attached to this release:
BFEFEEC74F545AE7D81FA09D2F79CDEA8FCE26A583AFAC34E6A0DE39DE26D8BA

SHA-256 sum for "guinget.exe" in the archive:
6A6954811AB858A8F078B67D74579AA2716894EDF14C18697CC775CF10C3CA8C

SHA-256 sum for "libguinget.dll" in the archive:
2FE467A29806D3B7901A39B3B2A0D54A46BBB7E586FCE59AE777D81DD3028BF0

SHA-256 sum for "update-manifests.bat" in the archive:
AFA421669D4856FB9136656B97CD2098478B1FE67AD5CB2326DA5A8BDA4BD36A

SHA-256 sum for "YamlDotNet.dll" in the archive:
632E1C37E67E5BE46766FFC9ED7790C22D1FE75A5B83AAB9EC4C0678414E5B82



## Added

- Installer scripts are now in the repository.
  
## Fixed

- Can't install packages like crystaldiskmark as "-e" isn't passed to winget. ([issue #24](https://github.com/DrewNaylor/guinget/issues/24))

## Changed

- Some wording here and there.

## Deprecation notices

- `update-manifests.bat` is deprecated. Its removal will be done in stages to slowly transition to a world that no longer relies on `update-manifests.bat` for any scenario:
  - For now it'll stay in the package, but be unused by default.  **<-- You Are Here**
  - Eventually the version in the package will be changed to be a simple script that tells you where to download the main script.
  - After a while it'll be fully removed from the package.
  - A while after that support for it will be fully removed from guinget. It's expected that support will be fully removed by the time guinget (and winget, but it may take longer for guinget to gain that feature) supports multiple sources, if not in the same version.
  - It may be possible that it'll go from being supported in a way that requires it to be enabled manually to being removed from the package, or having support be removed completely, all at once.
- Since the code to get details from winget is deprecated, it was commented out in version 0.1 alpha. This code may continue to exist in this state as an example for how to get info from winget.
