# guinget Version 0.1.1 Alpha Changelog
Released on 8/3/2020 (MM/DD/YYYY).

Sometimes I want to install a package interactively as I don't like the defaults, as is the case with LibreOffice, so this update introduces that functionality. To use it, simply check the `Install interactively (-i)` checkbox in the `Apply changes` window. This will persist across closing the window and restarting the application.

There are also some fixes and changes related to the `Apply changes` window, including one where double-clicking on the column header used to install the currently-selected package.

Some packages like CrystalDiskMark and LibreOffice may require administrative permissions to install, so you'll have to run guinget as an administrator.

Please be sure to read the Readme included with this version of guinget or [online](https://github.com/DrewNaylor/guinget/blob/master/docs/readmes/readme-v0.1.1-alpha.txt) as it has important info. Also refer to the [System Requirements](https://github.com/DrewNaylor/guinget/blob/master/docs/system-requirements.md).

If you are reading this in Notepad or another text editor, it displays best in Word Wrap view. Click on Format>Word Wrap on the top bar. Notepad++ users will find it under View>Word Wrap. Word Wrap is automatically done if viewing on GitHub or on the website.

## Hashes

MD5 checksums/hashes are not used for guinget as they are weaker than SHA-256. [More details](https://github.com/DrewNaylor/UXL-Launcher/issues/124), though they're not as relevant to guinget:


You can use Windows PowerShell to confirm the hash of the main guinget EXE file by running
`Get-FileHash .\guinget.exe -Algorithm SHA256` in the folder you extracted the archive to and comparing the output to my sums listed below. HowToGeek has a nice [article on this](https://www.howtogeek.com/67241/htg-explains-what-are-md5-sha-1-hashes-and-how-do-i-check-them/), but the Windows section is a bit further down on the page.

The PowerShell method can be used for all files listed below, though you'll have to switch out the filenames.

SHA-256 sum for "guinget_v0.1.1-alpha-quieter.exe", which is a quieter installer without the startup message:
EE7EE57E21BC999F68CFF63DF1DCCA6B9C6A22E2443AAC7406E9028298EA45A4

SHA-256 sum for "guinget_v0.1.1-alpha.exe", which is the main installer attached to this release:
924A4378503550E1D3061A6DA1D47970056BBDADC8D19131CDA43A6662979BCD

SHA-256 sum for "guinget.exe" in the archive:
77BE11957E22E4A3341F0D671E510981E7E7D45794FA89B861133EA71241A170

SHA-256 sum for "libguinget.dll" in the archive:
BE071A6B17AE209E0242777A7385250BD549E697B69F5B73425FDF597C6D971D

SHA-256 sum for "update-manifests.bat" in the archive:
AFA421669D4856FB9136656B97CD2098478B1FE67AD5CB2326DA5A8BDA4BD36A

SHA-256 sum for "YamlDotNet.dll" in the archive:
632E1C37E67E5BE46766FFC9ED7790C22D1FE75A5B83AAB9EC4C0678414E5B82



## Added

- Interactive installation option
  - Usable by checking the `Install interactively (-i)` checkbox in the `Apply changes` window
  - Setting persists across closing the window and restarting the application
  - Passes `-i` to winget along with the rest of the install command
  
## Fixed

- Double-clicking the column header in the `Apply changes` window would start installing the selected package, but now we make sure this doesn't happen.
- Column headers in the `Apply changes` window were sometimes too tall, but now they're closer to the height they should be.

## Changed

- Multi-select has been turned off in the `Apply changes` window as there's no code to handle that situation and it could be confusing.

## Deprecation notices

- `update-manifests.bat` is deprecated. Its removal will be done in stages to slowly transition to a world that no longer relies on `update-manifests.bat` for any scenario:
  - For now it'll stay in the package, but be unused by default.  **<-- You Are Here**
  - Eventually the version in the package will be changed to be a simple script that tells you where to download the main script.
  - After a while it'll be fully removed from the package.
  - A while after that support for it will be fully removed from guinget. It's expected that support will be fully removed by the time guinget (and winget, but it may take longer for guinget to gain that feature) supports multiple sources, if not in the same version.
  - It may be possible that it'll go from being supported in a way that requires it to be enabled manually to being removed from the package, or having support be removed completely, all at once.
- Since the code to get details from winget is deprecated, it was commented out in version 0.1 alpha. This code may continue to exist in this state as an example for how to get info from winget.